##parameters=theme=None, edit_mode='wysiwyg', REQUEST=None, **kw

tmtool = context.portal_themes 
if REQUEST is not None:
    kw.update(REQUEST.form)

styleprop = kw.get('styleprop', None)
if styleprop is None:
    return

mystyle = getattr(context, styleprop, None)
if mystyle is None:
    return

type = None
for obj in context.propertyMap():
   if obj['id'] == styleprop:
        type = obj.get('style')

if type is None:
   return 

if theme is None:
    theme = tmtool.getDefaultThemeName()

theme_container = tmtool.getThemeContainer(theme=theme)
mystyle_objs = theme_container.findStyles(mystyle)

if len(mystyle_objs) == 0:
    newstyle = theme_container.addPortalStyle(type_name=type)
    mystyle_objs = [newstyle]

oldstyle = mystyle_objs[0]
style = None
parents = oldstyle.findParents()

if len(parents) != 1:
    style = oldstyle.duplicate()
    context.manage_changeProperties({styleprop : style.getTitle()})
else:
    for s in tmtool.findStylesFor(type, context)['object']:
        if s.getTitle() == mystyle:
            style = s

if style is None:
    return
else:
    url = style.absolute_url() + '/edit_form?edit_mode=' + edit_mode + \
         '&style=' + type + '&theme=' + theme

if REQUEST is None:
    return style
else:
    REQUEST.RESPONSE.redirect(url)
